//	File:		LAPEqu.h
//
//	Copyright:	 1983-1993 by Apple Computer, Inc.
//				All rights reserved.
//
//	Version:	System 7.1 for ETO #11
//	Created:	Tuesday, March 30, 1993 18:00
//
//___________________________________________________________________________

#ifndef __LAPEQU__
#define __LAPEQU__ 1

//
// LAP Manager call codes passed in D0 (call at [ATalkHk2] + 2)
//
#define LRdDispatch		1				// Dispatch to protocol handler
#define LWrtInsert		2				// Insert in LAPWrite hook
#define LWrtRemove		3				// Remove from LAPWrite hook
#define LWrtGet			4				// Get who's in LAPWrite hook
#define LSetInUse		5				// Set address in use flag
#define LGetSelfSend	6				// Get value of self send flag
#define LAARPAttach		7				// Attach an AARP listener
#define LAARPDetach		8				// Detach an AARP listener
#define LGetATalkInfo	9				// Get AppleTalk info
#define LGetPortInfo	10				// Get port info
#define LOpenADEV		11				// Open ADEV file
#define LNSetInUse		12				// Port-based set-in-use call
#define LGetBridgeInfo	13				// Get bridge info
#define LSetATalkInfo	14				// Set AppleTalk info
#define LShutdownBridge	15				// Shut down bridge
#define LInit			16				// init run time LAP manager
#define LUsePortB		17				// rest use of printer port
#define LFreePortB		18				// grant use of printer port
#define LStatPortB		19				// obtain current printer port status
#define LNetAlert		20				// notify user of network alert condition
#define L802Attach		21				// attach an 802.2 protocol handler
#define L802Detach		22				// detach an 802.2 protocol handler
#define LAddAEQ			23				// add AppleTalk event queue entry
#define LRmvAEQ			24				// remove AppleTalk event queue entry
#define LGetAEQ			25				// get pointer to AppleTalk event queue
#define LLastCall		LGetAEQ			// Last valid call

//
// Flag bits passed in D1 on LWrtInsert
//
#define LWSelfSend		7				// ADEV handles self send
#define LWSrvrWks		5				// Honor server/wks bit
#define LWVMdefer		4				// buffer and defer incoming packets
#define LWReserved		0				// Reserved for internal use

//
// atlk call codes passed in D0 (call at atlk start plus 2)
//
#define AInstall		1				// Installation
#define AShutdown		2				// Shutdown
#define AGetInfo		3				// Get link information
#define AGetMCast		4				// Get multicast addr
#define ASetMCast		5				// Set multicast addr
#define ADelMCast		6				// Delete multicast addr
#define AOpen			7				// Open an ATlk
#define AClose			8				// Close an ATlk
#define AEnq			9				// send ENQ's for a node address
#define ADelAddr		10				// remove an established node address

//
// ADEV call code passed in D0 (call at ADEV start)
//
#define GetADEV			101				// Get next ADEV
#define SelectADEV		102				// Select ADEV
#define ReSelADEV		103				// Re-selected ADEV

#define LAPMgrPtr		0xB18			// This points to our start (???ATalkHk2?)
#define LAPMgrCall		2				// Offset to make LAP manager calls
#define atlkCall		2				// Offset to make atlk calls at

//
// Resource IDs
//
#define adevBaseID		-4032			// Base resource ID for ADEVs

//
// atlk AGetInfo call
//
typedef struct								// (big enough to handle 6 byte link addr)
	{
	unsigned short Version;					// version number
	unsigned short InfoLength;				// length of this rec
	unsigned long  LinkSpeed;				// speed of link in bits/second
	unsigned char  BandWidth;				// bandwidth factor
	unsigned char  Reserved[3];
	unsigned char  Flags;					// informative flags (see below)
	unsigned char  LinkAdrLen;				// link address length in bytes
	unsigned char  LinkAddress[6];			// start of link address (reserve 6 bytes)
	unsigned short MaxNodes;				// max. number of nodes (base zero)
	} ATlkInfo;								// link information

#define AInfoVers	3						// version number describes reply buffer below
#define AInfoSz		sizeof(ATlkInfo)		// size in bytes of reply buffer

//
// atlk AGetInfo flags
//
#define AtlkExtended	7						// bit in on if link has extended addressing
#define AtlkROnly		6						// true if link is for router only ports

//	Transition Queue Structures defined in LAPEqu.a are in AppleTalk.h

#endif
